(* question 2.3 *)
type 'a l_systeme = {
  axiome: 'a list;
  morphisme: 'a -> 'a list
};;

(* question 2.8 *)
taille_alphabet {
  morphisme =
    (function
       | 0 -> [0;1;2]
       | 1 -> [0]
       | 2 -> [3]
       | 3 -> [1]
       | _ -> failwith "bug");
  axiome=[0]};;
(* 4 *)

taille_alphabet {
  morphisme =
    (function
       | 0 -> [0;1;2]
       | 1 -> [0]
       | 2 -> [1]
       | 3 -> [1]
       | _ -> failwith "bug");
  axiome=[0]};;
(* 3 *)

let ecrit i = match i with
  | 0 -> "zero"
  | 1 -> "un"
  | 2 -> "deux"
  | 3 -> "trois"
  | 4 -> "quatre"
  | 5 -> "cinq"
  | 6 -> "six"
  | 7 -> "sept"
  | 8 -> "huit"
  | 9 -> "neuf"
  | _ -> invalid_arg "ecrit";;
let bizarre i =
  let i = ecrit i in
  let result = ref [] in
  for j = string_length i -1 downto 0 do
    result := (int_of_char i.[j] - 97) mod 10 :: !result;
  done;
  !result;;

taille_alphabet {morphisme=bizarre; axiome=[0]};; (* 10 *)

let ecrit i = match i with
  | 0 -> "zero"
  | 1 -> "un"
  | 2 -> "deux"
  | 3 -> "drei"
  | 4 -> "vier"
  | 5 -> "funf"
  | 6 -> "six"
  | 7 -> "seven"
  | 8 -> "ocho"
  | 9 -> "nueve"
  | _ -> invalid_arg "ecrit";;
let bizarre i =
  let i = ecrit i in
  let result = ref [] in
  for j = string_length i -1 downto 0 do
    result := (int_of_char i.[j] - 97) mod 10 :: !result;
  done;
  !result;;
taille_alphabet {morphisme=bizarre; axiome=[0]};; (* 9 *)
map (fun i -> i,bizarre i) [0;1;2;3;4;5;6;7;8;9];;


(* ********************************************************************** *)
(* section 2.3 *)
#open "graphics";;
open_graph"";;

type etat = {x:float; y:float; dir:float};;

type lettre =
  | A (* Avance *)
  | G (* Gauche *)
  | D (* Droite *)
;;

(* question 2.11 *)
let trace pas angle etat mot =

(* question 2.12 *)
let pi = acos (-1.);;

let main pas angle mot =
  clear_graph ();
  let x = size_x () / 2 in
  let y = size_y () / 2 in
  moveto x y;
  trace pas angle {x=float_of_int x; y=float_of_int y; dir=pi/.2.} mot;;

let ile = {
  morphisme = (function
    | A -> [A;G;A;D;A;D;A;A;G;A;G;A;D;A]
    | G -> [G]
    | D -> [D]);
  axiome = [A;D;A;D;A;D;A;D]
};;
main 160. (pi/.2.) (l_systeme 0 ile);;
main 40. (pi/.2.) (l_systeme 1 ile);;
main 10. (pi/.2.) (l_systeme 2 ile);;
main 0.5 (pi/.2.) (l_systeme 5 ile);;

let von_koch = {
  morphisme = (function
    | A -> []
    | G -> [G]
    | D -> [D]);
  axiome = []};;

main 1. (pi/.3.) (l_systeme 6 von_koch);;

(* question 2.13 *)
type lettre =
  | A (* Avance *)
  | V (* Vole *)
  | G (* Gauche *)
  | D (* Droite *)
  | S (* Sauvegarde *)
  | R (* Restauration *)
;;

let trace pas angle etat mot =
  let pile = stack__new () in
  let rec une_lettre etat = function
    | G -> (* renvoie le nouvel état *)
    | D ->
    | A ->
    | V ->
    | S -> stack__push etat pile; etat
    | R -> stack__pop pile in
  it_list une_lettre etat mot;;

(* question 2.14 *)
let main pas angle mot =
  clear_graph ();
  let x = size_x () / 2 in
  let y = size_y () / 2 in
  moveto x y;
  trace pas angle {x=float_of_int x; y=float_of_int y; dir=pi/.2.} mot;;

main 40. (pi/.4.) [
  S;
    S;D;D;A;R;A;S;A;D;D;A;R;D;D;A;
  R;D;D;V;V;
  S;
    G;G;A;A;D;D;D;A;A;A;G;G;G;A;A;
  R;V;V;V;
  A;G;G;A;G;G;A;D;D;A;D;D;A;];;

let dragon = {
    morphisme = (function
    | A -> [G;A;D;V;D;A;G;V;S;G;G;A;D;V;G;A;R]
    | V -> [V;V]
    | G -> [G]
    | D -> [D]
    | S -> [S]
    | R -> [R]);
  axiome = [A]};;
main 2. (pi/.2.) (l_systeme 8 dragon);;

(* 2 minutes de pause: *)
let ignore _ = ();; (* juste pour éviter un warning *)
for i=0 to 20 do
  ignore (main 2. (pi/.2.+.(float_of_int (i-10) /. 10.)) (l_systeme 8 dragon));
done;;

let arbre1 = {
  morphisme = (function
    | A -> [A;S;G;A;R;A;S;D;A;R;S;A;R]
    | V -> [V]
    | G -> [G]
    | D -> [D]
    | S -> [S]
    | R -> [R]);
  axiome = [A]};;
main 120. (pi/.7.) (l_systeme 1 arbre1);;
main 60. (pi/.7.) (l_systeme 2 arbre1);;
main 7. (pi/.7.) (l_systeme 5 arbre1);;

let arbre_Y = {
  morphisme = (function
    | A -> []
    | V -> [V]
    | G -> [G]
    | D -> [D]
    | S -> [S]
    | R -> [R]);
  axiome = [A]};;
main 100. (pi/.8.) (l_systeme 1 arbre_Y);;
main 50. (pi/.8.) (l_systeme 2 arbre_Y);;
main 25. (pi/.8.) (l_systeme 3 arbre_Y);;
main 20. (pi/.8.) (l_systeme 8 arbre_Y);;

(* question 2.15 *)
type lettre =
  | A (* Avance *)
  | G (* Gauche *)
  | D (* Droite *)
  | S (* Sauvegarde *)
  | R (* Restauration *)
  | B (* Bourgeon *)
  | T (* Tige *)
;;

let trace pas angle etat mot =

let main pas angle mot =
  clear_graph ();
  let x = size_x () / 2 in
  let y = size_y () / 2 in
  moveto x y;
  trace pas angle {x=float_of_int x; y=float_of_int y; dir=pi/.2.} mot;;

let arbre3 = {
  morphisme = (function
    | B -> [T;S;G;B;R;T;S;D;D;B;R;B]
    | T -> [T;A]
    | A -> [A]
    | G -> [G]
    | D -> [D]
    | S -> [S]
    | R -> [R]);
  axiome = [B]};;

main 10. (pi/.7.) (l_systeme 8 foo);;
;;
